import 'package:country_code_picker/country_code.dart';
import 'package:example/Constants/AppStrings.dart';
import 'package:example/Screens/OtpScreen.dart';
import 'package:example/Screens/LoginScreen.dart';
import 'package:example/Screens/CustomTabbar.dart';
import 'package:firebase_auth/firebase_auth.dart';
import 'package:firebase_core/firebase_core.dart';
import 'package:flutter/material.dart';
import 'package:google_sign_in/google_sign_in.dart';
import 'package:harish_package/SignUpScreenComponent.dart';
import 'package:toast/toast.dart';

class SignUpScreen extends StatefulWidget {
  static String tag = AppStrings.SIGN_UP_TAG;

  @override
  _SignUpScreenState createState() => _SignUpScreenState();
}

class _SignUpScreenState extends State<SignUpScreen> {
  final phoneNumberController = TextEditingController();
  final emailController = TextEditingController();
  final passwordController = TextEditingController();
  final firstNameController = TextEditingController();
  final lastNameController = TextEditingController();

  List<TabBar> tabWidget = [
    TabBar(tabs: <Widget>[
      Tab(
        text: AppStrings.EMAIL,
      ),
     /* Tab(
        text: AppStrings.EMAIL,
      ),*/
    ])
  ];

  List<String> name = ["Email","Mobile","Social"];

  String phoneNumber;
  String countryCode;
  var _formKey = GlobalKey<FormState>();
  var _phoneGlobalKey = GlobalKey<FormState>();

  //final FirebaseAuth _auth = FirebaseAuth.instance;
  //final GoogleSignIn googleSignIn = GoogleSignIn();

  @override
  void initState() {
    // TODO: implement initState
    super.initState();
    //firbaseInit();
  }

  @override
  void dispose() {
    // Clean up the controller when the widget is removed from the
    // widget tree.
    phoneNumberController.dispose();
    emailController.dispose();
    passwordController.dispose();
    firstNameController.dispose();
    lastNameController.dispose();

    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      body: SignUpScreenComponent(
        googleSignUp: googleSignUp,
        facebookSignUp: facebookSignUp,
        phoneNumberController: phoneNumberController,
        phoneNumberSignInFunction: phoneNumberSignInFunction,
        globalKey: _formKey,
        phoneGlobalKey: _phoneGlobalKey,
        emailController: emailController,
        passwordController: passwordController,
        firstNameController: firstNameController,
        lastNameController: lastNameController,
        emailPasswordSignInFunction: emailPasswordSignInFunction,
        signInFunction: signInPage,
        //emailTabName: "Email",
        emailWidgetEnable: true,
        //socialWidetEnable: true,
        //mobileWidgetEnable: true,
        //allWidgetEnable:true,
        tabWidget: tabWidget,
     //   nameArray: name,
      ),
    );
  }

  Future<void> googleSignUp() async {
    print("Google Login Revoked");

    /* final GoogleSignInAccount googleSignInAccount = await googleSignIn.signIn();
    final GoogleSignInAuthentication googleSignInAuthentication = await googleSignInAccount.authentication;

    final AuthCredential credential = GoogleAuthProvider.credential(
      accessToken: googleSignInAuthentication.accessToken,
      idToken: googleSignInAuthentication.idToken,
    );

    final UserCredential authResult = await _auth.signInWithCredential(credential);
    final User user = authResult.user;

    if (user != null) {
      assert(!user.isAnonymous);
      assert(await user.getIdToken() != null);

      final User currentUser = _auth.currentUser;
      assert(user.uid == currentUser.uid);

      print('signInWithGoogle succeeded: $user');

      return '$user';
    }

    return null;*/

    Toast.show("Google Sign in Method Calling", context);
   /* Navigator.push(context,
        MaterialPageRoute(builder: (BuildContext context) => CustomTabBar()));*/
  }

  Future<void> facebookSignUp() async {
    Toast.show("Facebook Sign in Method Calling", context);
    print("Facebook Login Revoked");
  }

  Future<void> emailPasswordSignInFunction() async {
    final isValid = _formKey.currentState.validate();
    if (!isValid) {
      return;
    }
    _formKey.currentState.save();
    print("email Password Sign In Function");
  }

  Future<void> signInPage() async {
    Navigator.pushReplacement(context,
        MaterialPageRoute(builder: (BuildContext context) => LoginScreen()));
  }

  Future<void> phoneNumberSignInFunction() async {
    final isValid = _phoneGlobalKey.currentState.validate();
    if (!isValid) {
      return;
    }
    _phoneGlobalKey.currentState.save();
    phoneNumber = phoneNumberController.text.toString();

    if (phoneNumber.isNotEmpty) {
      if (phoneNumber.length == 10) {
        Navigator.pushReplacement(context,
            MaterialPageRoute(builder: (BuildContext context) => OtpScreen()));
      } else {
        print("Phone number to short");
      }
    } else {
      print("Phone Number empty");
    }
  }
}
